#not only needed by ThOrMA
#Param.pm: simple routines and environment for command line argument processing

#Copyright (c) 2003 Thomas Orgis (thomas@orgis.org)
#This is Open Source, Distribution and Modification under the terms of the Artistic License
#see the file LICENSE in the package root

use Sys::Hostname;

#command line args parsing

#for full operation I create global
#%par_map("x","nameofx",...)
#%const = (nameofx,value,...) to place values in (so don't use it elsewhere)
#%par_help = (nameofx,help msg)
#i predefine const{help} with switch h!!!
#i predefine const{config} with switch I!!!


%const = ('help',0,'config',substr($0,0,rindex($0,'/')+1).'etc/hostconfig/'.substr($0,rindex($0,'/')+1,).'.'.hostname().'.conf');
unless(-e $const{config})
{
	my $pre = substr($0,0,rindex($0,'/')+1);
	$pre =~ s/\/bin\/$/\//;
	$const{config} = $pre.'etc/'.substr($0,rindex($0,'/')+1,).'.conf';
}



%par_map = ('h','help','I','config');
%par_help = ('h','show the help message (no value required...)','I','Which configfile to use');

sub NewPar #(name,value,switch,helpdescription)
{
	unless(defined $par_map{$_[2]})
	{
		$const{$_[0]} = $_[1];
		$par_map{$_[2]} = $_[0];
		$par_help{$_[2]} = $_[3];
		return 0;
	}
	else{print STDERR "NewPar: Tried to redefine an option ($_[2] \/ $_[0])! Programmer: please check this!\n"; return -1;}

}

sub SetPar
{
	my $p = shift;
	my $v = shift;
	my $log = shift;
	$log = 0 unless defined $log;
	if(length($p) == 1 and defined $par_map{$p})
	{
		print "Setting $par_map{$p} to $v\n" if $log;
		$const{$par_map{$p}} = $v; 
	}
	elsif( defined $const{$p} )
	{
		print "Setting $p to $v\n" if $log;
		$const{$p} = $v;
	}
	else{print "Ignoring unknown switch $p\n";}
}



sub ParmParse
{
	my $info = shift;
	my $log = shift;
	my %local_settings = ();
	while(defined $ARGV[0])
	{
		if($ARGV[0] =~ /^-([^-].*)$/)
		{
			my $a = $1;
			if($a =~ /^(.)=(.+)$/)
			{
				#conffile immediately
				if($1 eq 'I'){SetPar($1,$2);}
				else{$local_settings{$1} = $2;}
			}
			else
			{
				for(my $i = 0;$i < length($a); ++$i)
				{
					$local_settings{substr($a,$i,1)} = 1;
				}
			}
			shift(@ARGV);
		}
		else
		{
		  if($ARGV[0] =~ /^--(.+)/)	
			{
				my $opt = $1;
				if($opt =~ /(.+)=(.+)/)
				{
					$local_settings{$1} = $2;
				}
				else{ $local_settings{$1} = 1;}
				shift(@ARGV);
			}
			elsif($ARGV[0] eq '--')
			{
				shift(@ARGV); last;
			}
			else{ last; }
		}
	}
	if(-e $const{config})
	{
		if($log){ print "Parsing $const{config}...\n"; }
		if(open(CDAT,$const{config}))
		{
			while(<CDAT>)
			{
				if($_ =~ /^([^\#].+)=(.+)$/)
				{if($log){ print "Setting $1 to $2...\n"; } $const{$1} = $2;}
			}
			close(CDAT);
			if($log){ print "...done parsing.\n"; }
		}
		else{die "couldn\'t open it! ($!)\n";}
	}
	for(keys %local_settings)
	{
		&SetPar($_,$local_settings{$_},$log);
	}
	if((defined $info) && ($const{help}))
	{
		print "\n",$info,"\n\n"; 
		&ParmHelp();
		exit(0);
	}
}


sub ParmHelp
{
	if( defined $_[0] ){ print $_[0],"\n"; }
	print "Parameter input: -<option>[=<value>] or --<long-option>[=<value>] [[--] [filenames or other stuff maybe needed]]\n\n";
	print "Recognized Options:\n";
	print "OPTION: NAME; DESCRIPTION [VALUE]\n";
	for( sort keys %par_map )
	{
		print "$_: $par_map{$_}; $par_help{$_} [$const{$par_map{$_}}]\n";
	}
	print "hope I could help you. Bye.\n\n";
}

sub ParmInfo
{
	print "Settings:\n\n";
	for(sort keys %const)
	{print "$_ = $const{$_}\n";}
	print "\n";
}

1;
