#!/usr/bin/perl

#need general data format:

# data{x} = ((data1),(data2),...)
# so... $data{x}->[1][0] should mean the first value for x in the second row

#NO: I must at first adress the measurements... $dat{x}->[measurement_nr]->[dataset_nr]

#I need different headers... at least some function to split the axes info, too

package XnYCSV;

sub new
{
	my $class = shift;
	my $initfile = shift;
	my $self = {};
	bless $self, $class;
	$self->{Header} = [];

	if(defined $initfile){ $self->ReadData($initfile); }

	return $self;
}

my $zahl = '\+?\-?\d*\.?\d+e?E?\+?\-?\d*';
my $trenner = '\s+|,|;';

sub ReadData #(file)
{
	my $self = shift;
	%{$self->{Data}} = (); #initialisation
	my $f = shift;
	$self->ReadHeader($f);
	$self->{HeaderData} = $self->HeaderData(); 
	
	$self->{DataSets} = -1;
	
	if(open(LD, $f))
	{
		while(<LD>)
		{
			if($_ =~ /^($zahl)(.*)$/)
			{
				#we supposedly have a line with numerical data
				#save the x value
				my $x = $1;
				my $l = $2;
				#another measurement for x
				push(@{$self->{Data}->{$x}},[]); #a new one added
				#we're operating with this array ref now:
				my $ar = $self->{Data}->{$x}->[$#{$self->{Data}->{$x}}];
				#and save all those y values to be found
				while($l =~ /^($trenner)($zahl)(.*)$/)
				{
					#print "read $1 : $3\n";
					push(@{$ar}, $2);
					$l = $3;
				}
				if($self->{DataSets} > -1)
				{
					if( ($#{$ar}+1) != $self->{DataSets} ){ print STDERR "Warning: Number of Values found (",$#{$ar}+1,") does not match previously determined number of data sets ($self->{DataSets})!\n"; }
				}
				else
				{
					$self->{DataSets} = $#{$ar}+1;
				}
			}
		}
		close(LD);
		$self->{DataSets} = 
		return 0;
	}
	else
	{
		print STDERR "Konnte $f nicht ffnen ($!)!\n";
		return -1;
	}
}

sub WriteData #(file)
{
	my $self = shift;
	my $f = shift;
	unless(defined $f){ $wld = STDOUT; }
	else{ open(WLD, ">$f") or die "Cannot open $f for writing! ($!)\n"; $wld = WLD;}
	
	print $wld ${$self->RawHeader()};
	for( sort { $a <=> $b } keys %{$self->{Data}} )
	{
		my $x = $_;
		#print measurements after each other
		for(@{$self->{Data}->{$x}})
		{
			print $wld $x,"\t", join("\t", @{$_}), "\n";
		}
	}
	if($wld ne STDOUT){close(WLD);}
	return 0;
}

sub WriteSets#("file",list with data set numbers starting at 0)
{
	my $self = shift;
	my $f = shift;
	unless(defined $f && $f ne ""){ $wld = STDOUT; }
	else{ open(WLD, ">$f") or die "Cannot open $f for writing! ($!)\n"; $wld = WLD;}
	
	print $wld ${$self->RawHeader(@_)};
	for( sort { $a <=> $b } keys %{$self->{Data}} )
	{
		my $x = $_;
		#print measurements after each other
		for(@{$self->{Data}->{$x}})
		{
			print $wld $x;
			$row = $_;
			for(@_)
			{
				print $wld "\t",$row->[$_];
			}
			print $wld "\n";
		}
	}
	if($wld ne STDOUT){close(WLD);}
	return 0;
}

sub OnePointPerInterval #(interval width)
{
	my $self = shift;
	my $int = shift;
	my @inty = ();
	my %newdata = ();
	my $i = 0;
	my $firstx = undef;
	for( sort { $a <=> $b } keys %{$self->{Data}} )
	{
		my $x = $_;
		unless(defined $firstx)
		{
			$firstx = $x;
			if( $firstx < 0 )
			{
				while(((--$i-1)*$int) > $firstx)
				{
					#print "first downcount: ",$i*$int,"($firstx)\n";
				}
			}
			else
			{
				while(((++$i)*$int) < $firstx)
				{
					#print "first upcount: ",$i*$int,"($firstx)\n";
				}
			}
		}
		if($x >= $i*$int) # [start,end) ... maybe one could share a border between intervals
		{
			push(@inty, @{$self->{Data}->{$x}}) if $x == $i*$int; #take the ending border into account here
			if($#inty > -1)
			{
				#set data point
				@{$newdata{($i-0.5)*$int}} = ($self->Mean(\@inty)); 
			}
			while(((++$i)*$int) < $x)
			{
				#print "upcount: ",$i*$int,"($x)\n";
			}
			@inty = ();
		}
		
		push(@inty,@{$self->{Data}->{$x}}); #remember all points associated with this x, old ending border may become new start border here
		
	} 
	$self->{Data} = \%newdata;
	return 0;
}


sub ReadHeader #(file)
{
	my $self = shift;
	my $f = shift;
	$self->{Header} = [];
	
	if(open(LD, $f))
	{
		while(<LD>)
		{
			#why does the # get duplicated??? Not solving now, but this is _very_ strange!
			if($_ =~ /\S/ && $_ =~ /^#*([^\d\+\-].*)$/){ push(@{$self->{Header}}, $1); }
			else{ last; }
		}
		close(LD);
		return 0;
	}
	else
	{
		print STDERR "Konnte $f nicht ffnen ($!)!\n";
		return -1;
	}
}

sub RawHeader
{
	my $self = shift;
	my $hs = '';
	if($#_ == -1 or $#{$self->{HeaderData}->{Y}} == -1)
	{
		for(@{$self->{Header}})
		{
			$hs .= '#'.$_."\n";
		}
	}
	else
	{
		my $pre = '#';
		for(my $i = 0; $i < $#{$self->{Header}}; ++$i)
		{
			$hs .= '#'.$self->{Header}->[$i]."\n";
		}
		$hs .= "#\"".$self->{HeaderData}->{X}."\"";
		for(@_)
		{
			$hs .= "\t\"".$self->{HeaderData}->{Y}->[$_]."\"";
			if($pre ne '#'){ $pre .= ", "; }
			if( $self->{HeaderData}->{Y}->[$_] =~ /^(.+)\s*\/.*$/ )
			{
				$pre .= $1;
			}
			else
			{
				$pre .= $self->{HeaderData}->{Y}->[$_];
			}
		}
		$hs .= "\n";
		$hs = $pre."\n".$hs;
	}
	return \$hs;
}

sub HeaderData #gets title and axes, if possible...
{
	my $self = shift;
	my %hd = ('Title','','X','','Y','');
	my $i = $#{$self->{Header}};
	my $ax = $i;
	if( $i >= 0)
	{
		if( $i > 0)
		{
			#that's great! we'll be not too cautionous
			if($self->{Header}->[0] =~ /^"?(.+)"?$/){ $hd{Title} = $1; }
		}
		else
		{
			$ax = 0;
		}
		#in every case: guess axes
		if($self->{Header}->[$ax] =~ /^"?([^"]+)"?($trenner)"?([^"]+)"?(.*)$/)
		{
			$hd{X} = $1; 
			$hd{Y}->[0] = $3;
			my $l = $4;
			while($l =~ /^($trenner)"?([^"]+)"?(.*)$/)
			{
				push(@{$hd{Y}}, $2);
				$l = $3;
			}
		} 
	}
	return \%hd;
}

sub Y
{
	my $self=shift;
	my $y = shift;
	if(defined $self->{Data}->{$y}){ return $self->{Data}->{$y}->[0]; }
	else{ return undef; }
}

sub YValuesInXRange
{
	my $self=shift;
	my $start = shift;
	my $end = shift;
	my @list = ();
	if($start > $end){my $swp = $start; $start = $end; $end = $swp;}
	for( sort { $a <=> $b } keys %{$self->{Data}} )
	{
		if( $_ >= $start && $_ <= $end)
		{
			push(@list, @{$self->{Data}->{$_}});
		}
		if( $_ > $end){ last; }
	}
	return \@list;
}

sub Mean
{
	my $self = shift;
	my $list = shift;
	#calculate arithmetic mid
	my $y = 0;
	if($#{$list} == -1){return undef;}
	if($#{$list} == 0){return $list->[0];}
	for(@{$list})
	{
		#print "Val: $_\n";
		$y += $_;
	}
	return $y / ($#{$list}+1);
}
